//+------------------------------------------------------------------+
//|                                      ft_billwillams_trader_1.mq4 |
//|            Copyright 2016, Aliaksandr Kryvanos (aka GoldenMoney) |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Aliaksandr Kryvanos (aka GoldenMoney)"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

extern string FT1 = "------ :----------";
extern int CountBarsFractal = 5; //     
//extern int ClassicFractal = 1; //   
extern int MaxDistance = 1000; //        
extern string FT2 = "------   :----------";
extern int indent = 10; //       
extern int TypeEntry = 1; //     1 -    2 -    3       
extern int RedContol = 1; //         
extern string FT3 = "------ :----------";
extern int jaw_period = 13; // -       ( ).
extern int jaw_shift = 8; // -        .
extern int teeth_period = 8; // -       ( ).
extern int teeth_shift = 5; // -        .
extern int lips_period = 5; //  -       ( ).
extern int lips_shift = 3; // -        .
extern int ma_method = 0; //-  0  3  .         (Moving Average).
extern int applied_price = 4; // -  0  6  -    .      .
extern string FT4 = "-------    :----------";
extern int TrendAligControl = 1; //     
extern int jaw_teeth_distense = 20; //    
extern int teeth_lips_distense = 20; //    
extern string FT5 = "-------   :----------";
extern int CloseDropTeeth = 1; //       . 0 -  1 -   2   
extern int CloseReversSignal = 1; //    1-    2 -     0 
//extern string FT6 = "-------  StopLoss :----------";
//extern int TrailingGragus = 1; //      ,       ,       
//extern int smaperugol = 15;
//extern int raznica = 5;
extern string FT7 = "-------  StopLoss  TakeProfit   :----------";
extern double StopLoss = 200;
extern double TakeProfit = 1500;
extern double Lots = 1.0;
extern int Magic = 16384;
///---
extern string set1 = "==== Time Filter ====";
extern bool UseTimeFilter = true; //    
extern string TradingDays = "1,2,3,4,5"; // : 1-,2-,3-,4-,5-
extern int MondayHourStart = 1; //    
extern int FridayHourStop = 22; //    
extern int Ea_Start_Hour = 1; // 
extern int Ea_Start_Minute = 0;
extern int Ea_Stop_Hour = 23;
extern int Ea_Stop_Minute = 50;

//extern string set2 = "==== Trailing MA step ====";
//extern int TrailingMAStep = 10;

extern string set3 = "==== Trailing Settings ====";
extern int TrailingStart = 20;
extern int TrailingDistance = 8;
extern int TrailingStep = 5;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
  // if (TrailingGragus != 1)
  // {
     TrailingStartStepDistance();
  // }
   if (!Tradetime(UseTimeFilter,Ea_Start_Hour,Ea_Start_Minute,Ea_Stop_Hour,Ea_Stop_Minute))
     return;
     
	ClassicFractal();
	return;
   
  }

double oldopb, opb, ops, oldops, otkatb, otkats;
int fractalnew, vpravovlevo, numsredbar, colish, err;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int ClassicFractal()
{
	int buy,
	sell;
	double sl,
	tp;

	// 
	ClassicFractalPosManager();

	buy = 0;
	sell = 0;
	for (int i = 0; i < OrdersTotal(); i++)
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
		  if (OrderType() == OP_BUY)
		  {
			  buy = 1;
		  }
		  if (OrderType() == OP_SELL)
		  {
			  sell = 1;
		  }
		}
	}   

	//      
	vpravovlevo = (CountBarsFractal - 1) / 2;
	numsredbar = (CountBarsFractal - vpravovlevo);
	colish = numsredbar - 1;

	/*----------------------------------------------------------------------------------*/

	//   
	if (High[numsredbar] > High[iHighest(NULL, 0, MODE_HIGH, colish, numsredbar + 1)] && High[numsredbar] > High[iHighest(NULL, 0, MODE_HIGH, colish, 1)] && (RedContol(Close[1], 0) == true && RedContol == 1))
	{
		opb = NormalizeDouble(High[numsredbar] + indent * Point, 4);

	}
	//       
	if (buy == 0 && ((Ask > opb && TypeEntry == 1) || (Close[1] > opb && TypeEntry == 2))
		 && opb != oldopb && MaxDistance(opb) == true && opb > 0
		 && ((RedContol(Close[1], 0) == true && RedContol == 1) || RedContol == 0)
		 && ((TrendAligControl(0) == true && TrendAligControl == 1) || TrendAligControl == 0))
	{
		oldopb = opb;
		sl = NormalizeDouble(Bid - StopLoss * Point, Digits);
		tp = NormalizeDouble(Bid + TakeProfit * Point, Digits);
		if (OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, sl, tp, "FOREX", Magic, 10, Green) == -1)
		  Print("Error send buy order # ", GetLastError());
	}

	/*----------------------------------------------------------------------------------*/

	//   
	if (Low[numsredbar] < Low[iLowest(NULL, 0, MODE_LOW, colish, numsredbar + 1)] && Low[numsredbar] < Low[iLowest(NULL, 0, MODE_LOW, colish, 0)] && (RedContol(Close[1], 1) == true && RedContol == 1))
	{
		ops = NormalizeDouble(Low[numsredbar] - indent * Point, 4);

	}
	//       
	if (sell == 0 && ((Bid < ops && TypeEntry == 1) || (Close[1] < ops && TypeEntry == 2))
		 && oldops != ops && MaxDistance(ops) == true
		 && ((RedContol(Close[1], 1) == true && RedContol == 1) || RedContol == 0)
		 && ((TrendAligControl(1) == true && TrendAligControl == 1) || TrendAligControl == 0))
	{
		oldops = ops;
		sl = NormalizeDouble(Ask + StopLoss * Point, Digits);
		tp = NormalizeDouble(Ask - TakeProfit * Point, Digits);
		if (OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, sl, tp, "FOREX", Magic, 10, Red) == -1)
		  Print("Error send sell order # ", GetLastError());
	}

	return (0);
}

bool MaxDistance(double entryprice)
{
	double lips = iMA(NULL, 0, lips_period, lips_shift, ma_method, applied_price, 1);

	if (MathAbs(entryprice - lips) < MaxDistance * Point)
	{
		return (true);
	}
	return (false);
}

bool RedContol(double entryprice, int type)
{
	double teeth = iMA(NULL, 0, teeth_period, teeth_shift, ma_method, applied_price, 1);

	if (entryprice > teeth && type == 0)
	{
		return (true);
	}
	if (entryprice < teeth && type == 1)
	{
		return (true);
	}
	return (false);
}

bool TrendAligControl(int type)
{
	double teeth = iMA(NULL, 0, teeth_period, teeth_shift, ma_method, applied_price, 1);
	double lips = iMA(NULL, 0, lips_period, lips_shift, ma_method, applied_price, 1);
	double jaw = iMA(NULL, 0, jaw_period, jaw_shift, ma_method, applied_price, 1);

	if (type == 0 && lips - teeth > teeth_lips_distense * Point && teeth - jaw > jaw_teeth_distense * Point)
	{
		return (true);
	}
	if (type == 1 && teeth - lips > teeth_lips_distense * Point && jaw - teeth > jaw_teeth_distense * Point)
	{
		return (true);
	}

	return (false);
}

int ClassicFractalPosManager()
{
	int i,buy,sell;
	double jaw = iMA(NULL, 0, jaw_period, jaw_shift, ma_method, applied_price, 1);
	double teeth = iMA(NULL, 0, teeth_period, teeth_shift, ma_method, applied_price, 1);
	double lips = iMA(NULL, 0, lips_period, lips_shift, ma_method, applied_price, 1);
	double lipsl = iMA(NULL, 0, lips_period, lips_shift, ma_method, applied_price, 2);
	//double sma = iMA(NULL, 0, smaperugol, 0, MODE_SMA, PRICE_CLOSE, 1);
	//double smal = iMA(NULL, 0, smaperugol, 0, MODE_SMA, PRICE_CLOSE, 2);

	buy = 0;
	sell = 0;
	for (i = 0; i < OrdersTotal(); i++)
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
		  if (OrderType() == OP_BUY)
		  {
			  buy = 1;
		  }
		  if (OrderType() == OP_SELL)
		  {
			  sell = 1;
		  }
		}
	}

	for (i = 1; i <= OrdersTotal(); i++)
	{
		if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_BUY && ((CloseDropTeeth == 1 && Bid <= jaw) || (CloseDropTeeth == 2 && Close[1] <= jaw)))
			{
				if (!OrderClose(OrderTicket(), Lots, Bid, 3, Violet)) Print("Error close buy order # ", GetLastError());
				return (0);
			}
		}

		if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_BUY &&
				((CloseReversSignal == 1 && Low[numsredbar] < Low[iLowest(NULL, 0, MODE_LOW, colish, numsredbar + 1)] && Low[numsredbar] < Low[iLowest(NULL, 0, MODE_LOW, colish, 0)])
					 || (CloseReversSignal == 2 && sell == 1)))
			{
				if (!OrderClose(OrderTicket(), Lots, Bid, 3, Violet)) Print("Error close buy order # ", GetLastError());
				return (0);
			}
		}

		/*if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_BUY && TrailingGragus == 1 && lips - lipsl > sma - smal && OrderProfit() > 0)
			{
				if (NormalizeDouble(OrderStopLoss(),Digits) < NormalizeDouble(lips - TrailingMAStep * Point,Digits))
				{
					if (!OrderModify(OrderTicket(), OrderOpenPrice(), lips - TrailingMAStep * Point, OrderTakeProfit(), 0, White))					
					  Print("Error modify buy order #", (string)err);
					return (0);
				}
			}
		}*/

		/*if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_BUY && TrailingGragus == 1 && lips - lipsl <= sma - smal && OrderProfit() > 0)
			{
				if (NormalizeDouble(OrderStopLoss(),Digits) < NormalizeDouble(teeth - TrailingMAStep * Point,Digits) || (lips > teeth && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(teeth - TrailingMAStep * Point,Digits)))
				{
					if (!OrderModify(OrderTicket(), OrderOpenPrice(), teeth - TrailingMAStep * Point, OrderTakeProfit(), 0, White))					
					  Print("Error modify buy order #", (string)err);
					return (0);
				}
			}
		}*/

		if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_SELL && ((CloseDropTeeth == 1 && Ask >= jaw) || (CloseDropTeeth == 2 && Close[1] >= jaw)))
			{
				if (!OrderClose(OrderTicket(), Lots, Ask, 3, Violet)) Print("Error close sell order # ", GetLastError());
				return (0);
			}
		}

		if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_SELL && ((CloseReversSignal == 1 && High[numsredbar] > High[iHighest(NULL, 0, MODE_HIGH, colish, numsredbar + 1)] && High[numsredbar] > High[iHighest(NULL, 0, MODE_HIGH, colish, 1)])
					 || (CloseReversSignal == 2 && buy == 1)))
			{
				if (!OrderClose(OrderTicket(), Lots, Ask, 3, Violet)) Print("Error close sell order # ", GetLastError());
				return (0);
			}
		}

		/*if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_SELL && TrailingGragus == 1 && lipsl - lips < smal - sma && OrderProfit() > 0)
			{
				if (NormalizeDouble(OrderStopLoss(),Digits) > NormalizeDouble(lips + TrailingMAStep * Point,Digits))
				{
					if (!OrderModify(OrderTicket(), OrderOpenPrice(), lips + TrailingMAStep * Point, OrderTakeProfit(), 0, White))
					  Print("Error modify sell order #", (string)err);
					return (0);
				}
			}
		}*/

		/*if (OrderSelect(i - 1, SELECT_BY_POS) == true)
		{
			if (OrderType() == OP_SELL && TrailingGragus == 1 && lipsl - lips > smal - sma && OrderProfit() > 0)
			{
				if (NormalizeDouble(OrderStopLoss(),Digits) > NormalizeDouble(teeth + TrailingMAStep * Point,Digits) || (lips < teeth && NormalizeDouble(OrderStopLoss(),Digits) != NormalizeDouble(teeth + TrailingMAStep * Point,Digits)))
				{
					if (!OrderModify(OrderTicket(), OrderOpenPrice(), teeth + TrailingMAStep * Point, OrderTakeProfit(), 0, White))
					  Print("Error modify sell order #", (string)err);
					return (0);
				}
			}
		}*/
	}
	return (0);
}
//---
void TrailingStartStepDistance()
{ 
	for (int i = OrdersTotal() - 1; i >= 0; i--)
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
		{
			if (OrderType() == OP_BUY && OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
			{
				if (Bid - OrderOpenPrice() > TrailingStart * Point)
				{
					if (Bid - OrderStopLoss() > (TrailingDistance + TrailingStep - 1) * Point )
					{
						if (!OrderModify(OrderTicket(), OrderOpenPrice(), Bid - TrailingDistance * Point, OrderTakeProfit(), 0, clrAqua))
							Print("TrailingStartStepDistance error " + (string)GetLastError());
					}
				}
			}
			if (OrderType() == OP_SELL && OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
			{
				if (OrderOpenPrice() - Ask > TrailingStart * _Point)
				{
					if (OrderStopLoss() - Ask > (TrailingDistance + TrailingStep - 1) * _Point)
					{
						if (!OrderModify(OrderTicket(), OrderOpenPrice(), Ask + TrailingDistance * Point, OrderTakeProfit(), 0, clrAqua))
							Print("TrailingStartStepDistance error " + (string)GetLastError());
					}
				}
			}
		}
	}
}
//---
bool Tradetime(bool Use_time_filter,int StartHour,int StartMinute,int EndHour,int EndMinute)
{
	bool TodayTrading = false;
	bool TradingTime = false;

	datetime SessionStart = StrToTime((string)StartHour + ":" + (string)StartMinute);
	datetime SessionEnd = StrToTime((string)EndHour + ":" + (string)EndMinute);

	string day = IntegerToString(DayOfWeek());

	int pos = StringFind(TradingDays, day, 0);
	if (pos >= 0)
		TodayTrading = true;

	// exp: 6-23
	if (StartHour < EndHour)
	{
		if (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd)
			TradingTime = true;
	}
	// exp: 23-6
	if (StartHour > EndHour)
	{
		if ((TimeCurrent() > SessionStart && TimeHour(TimeCurrent()) < 24) ||
			(TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd))
			TradingTime = true;
	}
	if (StartHour == EndHour)
	{
		if (Hour() == StartHour && Minute() >= StartMinute && Minute() <= EndMinute)
			TradingTime = true;
	}

	if (DayOfWeek() == 1 && Hour() < MondayHourStart)
		TradingTime = false;

	if (DayOfWeek() == 5 && Hour() >= FridayHourStop)
		TradingTime = false;

	if (!TodayTrading)
		TradingTime = false;

	if (Use_time_filter != true)
		TradingTime = true;

	return (TradingTime);
}
//+------------------------------------------------------------------+
